﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using PcapDotNet.Core.Extensions;

namespace PcapDotNet.Core.Test
{
    /// <summary>
    /// Summary description for LivePacketDeviceExtensionsTests
    /// </summary>
    [TestClass]
    public class LivePacketDeviceExtensionsTests
    {
        /// <summary>
        /// Gets or sets the test context which provides
        /// information about and functionality for the current test run.
        /// </summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException), AllowDerivedTypes = false)]
        public void GetNetworkInterfaceNullTest()
        {
            Assert.IsNotNull(LivePacketDeviceExtensions.GetNetworkInterface(null));
            Assert.Fail();
        }
        
        [TestMethod]
        public void GetMacAddressTest()
        {
            foreach (LivePacketDevice device in LivePacketDevice.AllLocalMachine)
            {
                Assert.IsNotNull(device.GetMacAddress());
            }
        }

        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException), AllowDerivedTypes = false)]
        public void GetGuidNullDeviceTest()
        {
            Assert.IsNotNull((null as LivePacketDevice).GetGuid());
            Assert.Fail();
        }
    }
}